<?xml version="1.0" encoding="utf-8"?>
<!-- Copyright (C) 2016 The Android Open Source Project

     Licensed under the Apache License, Version 2.0 (the "License");
     you may not use this file except in compliance with the License.
     You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

     Unless required by applicable law or agreed to in writing, software
     distributed under the License is distributed on an "AS IS" BASIS,
     WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     See the License for the specific language governing permissions and
     limitations under the License.
-->
<manifest xmlns:android="http://schemas.android.com/apk/res/android"
    xmlns:tools="http://schemas.android.com/tools"
    package="android.car.cluster"
    coreApp="true"
    android:process="android.car.cluster"
    android:sharedUserId="android.uid.cluster">

    <uses-sdk android:targetSdkVersion="25" android:minSdkVersion="29"/>

    <protected-broadcast android:name="android.car.cluster.NAVIGATION_STATE_UPDATE"/>

    <!-- We set TYPE_SYSTEM_ALERT window flag to presentation in order
         to show it outside of activity context -->
    <uses-permission android:name="android.permission.SYSTEM_ALERT_WINDOW"/>
    <uses-permission android:name="android.permission.CONTROL_INCALL_EXPERIENCE"/>
    <uses-permission android:name="android.permission.WRITE_SECURE_SETTINGS"
        tools:ignore="ProtectedPermissions"/>
    <uses-permission android:name="android.permission.MANAGE_ACTIVITY_TASKS"/>
    <uses-permission android:name="android.permission.INJECT_EVENTS"/>
    <uses-permission android:name="android.permission.INTERNET" />
    <uses-permission android:name="android.permission.INTERNAL_SYSTEM_WINDOW"/>
    <!-- Required by 'singleUser' service attribute -->
    <uses-permission android:name="android.permission.INTERACT_ACROSS_USERS"/>
    <!-- Required by 'startActivityAsUser' -->
    <uses-permission android:name="android.permission.INTERACT_ACROSS_USERS_FULL"/>
    <!-- Required to detect the current user in the device -->
    <uses-permission android:name="android.permission.MANAGE_USERS" />
    <!-- Required to launch navigation apps -->
    <uses-permission android:name="android.car.permission.CAR_INSTRUMENT_CLUSTER_CONTROL"/>
    <!-- Required to watch activities running on the cluster -->
    <uses-permission android:name="android.permission.SET_ACTIVITY_WATCHER"/>
    <!-- Required to show car sensor data -->
    <uses-permission android:name="android.car.permission.CAR_ENERGY"/>
    <uses-permission android:name="android.car.permission.CAR_POWERTRAIN"/>
    <uses-permission android:name="android.car.permission.CAR_INFO"/>
    <uses-permission android:name="android.car.permission.CAR_ENGINE_DETAILED"/>

    <!-- Required to query packages in Android 11+ -->
    <uses-permission android:name="android.permission.QUERY_ALL_PACKAGES" />

    <uses-permission android:name="android.permission.READ_PHONE_STATE" />

    <application android:label="@string/app_name"
                 android:icon="@mipmap/ic_launcher"
                 android:directBootAware="true">
        <service android:name=".ClusterRenderingService"
                 android:exported="false"
                 android:singleUser="true"
                 android:permission="android.car.permission.BIND_INSTRUMENT_CLUSTER_RENDERER_SERVICE"/>

        <service android:name=".LoggingClusterRenderingService"
                 android:exported="false"
                 android:permission="android.car.permission.BIND_INSTRUMENT_CLUSTER_RENDERER_SERVICE"/>

        <activity android:name=".MainClusterActivity"
            android:exported="false"
            android:showForAllUsers="true"
            android:theme="@style/Theme.ClusterTheme">
            <meta-data android:name="distractionOptimized" android:value="true"/>
            <intent-filter>
                <action android:name="android.intent.action.MAIN"/>
                <category android:name="android.intent.category.DEFAULT"/>
            </intent-filter>
        </activity>

        <activity android:name=".FakeFreeNavigationActivity"
            android:exported="false"
            android:showForAllUsers="true"
            android:theme="@android:style/Theme.NoTitleBar.Fullscreen"
            android:launchMode="singleInstance"
            android:resizeableActivity="true"
            android:allowEmbedded="true">
            <meta-data android:name="distractionOptimized" android:value="true"/>
        </activity>

        <activity android:name=".EmptyNavigationActivity"
                  android:exported="false"
                  android:theme="@android:style/Theme.NoTitleBar.Fullscreen"
                  android:launchMode="singleInstance"
                  android:resizeableActivity="true"
                  android:allowEmbedded="true">
            <meta-data android:name="distractionOptimized" android:value="true"/>
        </activity>
    </application>
</manifest>
